# -*- coding: utf-8 -*-
import mod.client.extraClientApi as clientApi

CompFactory = clientApi.GetEngineCompFactory()


class CustomEntityClientSystem(clientApi.GetClientSystemCls()):

    def __init__(self, namespace, name):
        super(CustomEntityClientSystem, self).__init__(namespace, name)
        self.ListenEvent()

    def ListenEvent(self):
        self.ListenForEvent(clientApi.GetEngineNamespace(), clientApi.GetEngineSystemName(), "OnLocalPlayerStopLoading",
                            self, self.OnLocalPlayerStopLoading)
        self.ListenForEvent(clientApi.GetEngineNamespace(), clientApi.GetEngineSystemName(), "AddEntityClientEvent",
                            self, self.OnAddEntityClientEvent)

    def OnLocalPlayerStopLoading(self, args=None):
        gameComp = CompFactory.CreateGame(clientApi.GetLevelId())
        zombieEntityList = gameComp.GetEntitiesAroundByType(clientApi.GetLocalPlayerId(), 48,
                                                            clientApi.GetMinecraftEnum().EntityType.Zombie)
        for _entityId in zombieEntityList:
            # 这里考虑的存量的僵尸
            self.RegisterZombieAnimate(_entityId)

    def OnAddEntityClientEvent(self, args):
        entityId = args['id']
        engineTypeStr = args['engineTypeStr']
        # 这里是考虑的新增的僵尸
        if engineTypeStr == 'minecraft:zombie':
            self.RegisterZombieAnimate(entityId)

    def RegisterZombieAnimate(self, entityId=None):
        if entityId is None:
            entityId = clientApi.GetLevelId()
        actorRender = CompFactory.CreateActorRender(entityId)
        actorIdentifier = 'minecraft:zombie'
        actorRender.AddActorAnimation(actorIdentifier, "custom_attack", "animation.player.swim")
        actorRender.AddActorScriptAnimate(actorIdentifier, "custom_attack", "query.variant == 1.0")
        res = actorRender.RebuildActorRender(actorIdentifier)
        print '================RegisterZombieAnimate=========', res
